####################################
#
# Grey
#
# Simple program to convert
# between Celcius and Fahrenheit
#
# 27/06/16
#
####################################

from tkinter import *
from tkinter import messagebox
#from menubar import *

class conv(object):

    def convertCel2Fah(self,var):
        try:
            var.fahTemp.set(var.celTemp.get() *  9.0/5.0 + 32)
        except ValueError as e:
            messagebox.showinfo("",e)

    def convertFah2Cel(self,var):
        try:
            var.celTemp.set((var.fahTemp.get() - 32.0) *  5.0/9.0)
        except ValueError as e:
            messagebox.showinfo("",e)
            
    def convert(self,var):
        if (var.check.get()==0):
            self.convertCel2Fah(var)
        else:
            self.convertFah2Cel(var)    

class menubar(conv):

    def copyr(self):
        messagebox.showinfo("","By Grey, 2016")
    
    def createFileMenu(self,bar,root,var):
        fileMenu = Menu(bar, tearoff=0)
        fileMenu.add_command(label="Run", command=lambda: conv.convert(self,var))
        fileMenu.add_separator()
        fileMenu.add_command(label="Exit", command=root.destroy)
        return fileMenu

    def createHelpMenu(self,bar,root):
        helpMenu = Menu(bar, tearoff=0)
        helpMenu.add_command(label="Help", command=self.win)
        helpMenu.add_command(label="About", command=self.copyr)
        return helpMenu

    def createMenu(self,root,var):
        bar = Menu(root)
        fileMenu=self.createFileMenu(bar,root,var)
        helpMenu=self.createHelpMenu(bar,root)
        bar.add_cascade(label="File", menu=fileMenu)     
        bar.add_cascade(label="Help", menu=helpMenu)
        root.config(menu=bar)

    def win(self):
        win = Tk()
        win.title("Help")
        help1 = Label (win,text = "This program converts between\n celcius and fahrenheit") 
        help1.pack()
        win.mainloop()

class window(conv):

    def __init__(self):
        self.check1=None
        self.celLabel=None
        self.fahLabel=None
        self.celEntry=None
        self.fahEntry=None
        self.convertButton=None
        
    def setupWin(self,var):
    
        self.check1 = Checkbutton(text = "Fahrenheit to Celcius", variable = var.check, \
                            onvalue = 1, offvalue = 0)

        self.celLabel = Label (text = "Celcius: ", font = ("Arial", 16), fg = "red")
        self.fahLabel = Label (text = "Fahrenheit: ", font = ("Arial", 16), fg = "blue")
        self.celEntry = Entry (width = 10, bd = 5, textvariable = var.celTemp)
        self.fahEntry = Entry (width = 10, bd = 5, textvariable = var.fahTemp)
        self.convertButton =Button (text = "Convert", command=lambda: conv.convert(self,var))

    def packWin(self):
        
        self.celLabel.pack()
        self.celEntry.pack()
        self.fahLabel.pack()
        self.fahEntry.pack()
        self.check1.pack()
        self.convertButton.pack()

class setVariables(object):
    def __init__(self):
        self.celTemp = DoubleVar()
        self.celTemp.set(int(0))
        self.fahTemp = DoubleVar()
        self.fahTemp.set(int(0))
        self.check = IntVar()
        self.check.set(0)

class tempConvert(object):

    def runTempConvert(self):
    
        root = Tk()
        var=setVariables()
        m=menubar()
        w=window()
        m.createMenu(root,var)
        w.setupWin(var)
        w.packWin()
        root.mainloop()

if __name__ == '__main__':
    w=tempConvert()
    w.runTempConvert()


